clang 10.0.0git

Public Member Functions | List of all members
clang::JSONDumper Class Reference

`#include "clang/AST/JSONNodeDumper.h"`

Inheritance diagram for clang::JSONDumper:
[legend]
Collaboration diagram for clang::JSONDumper:
[legend]

## Public Member Functions
| JSONDumper (raw_ostream &OS, const SourceManager &SrcMgr, ASTContext &Ctx, const PrintingPolicy &PrintPolicy, const comments::CommandTraits *Traits)
JSONNodeDumper & | doGetNodeDelegate ()
void | VisitFunctionTemplateDecl (const FunctionTemplateDecl *FTD)
void | VisitClassTemplateDecl (const ClassTemplateDecl *CTD)
void | VisitVarTemplateDecl (const VarTemplateDecl *VTD)
Public Member Functions inherited from clang::ASTNodeTraverser< JSONDumper, JSONNodeDumper >
void | setDeserialize (bool D)
bool | getDeserialize () const
void | SetTraversalKind (ast_type_traits::TraversalKind TK)
void | Visit (const Decl *D)
void | Visit (const Stmt *Node, StringRef Label={})
void | Visit (QualType T)
void | Visit (const Type *T)
void | Visit (const Attr *A)
void | Visit (const CXXCtorInitializer *Init)
void | Visit (const TemplateArgument &A, SourceRange R={}, const Decl *From=nullptr, const char *Label=nullptr)
void | Visit (const BlockDecl::Capture &C)
void | Visit (const OMPClause *C)
void | Visit (const GenericSelectionExpr::ConstAssociation &A)
void | Visit (const comments::Comment *C, const comments::FullComment *FC)
void | Visit (const ast_type_traits::DynTypedNode &N)
void | dumpDeclContext (const DeclContext *DC)
void | dumpTemplateParameters (const TemplateParameterList *TPL)
void | dumpASTTemplateArgumentListInfo (const ASTTemplateArgumentListInfo *TALI)
void | dumpTemplateArgumentLoc (const TemplateArgumentLoc &A, const Decl *From=nullptr, const char *Label=nullptr)
void | dumpTemplateArgumentList (const TemplateArgumentList &TAL)
void | dumpObjCTypeParamList (const ObjCTypeParamList *typeParams)
void | VisitComplexType (const ComplexType *T)
void | VisitLocInfoType (const LocInfoType *T)
void | VisitPointerType (const PointerType *T)
void | VisitBlockPointerType (const BlockPointerType *T)
void | VisitReferenceType (const ReferenceType *T)
void | VisitMemberPointerType (const MemberPointerType *T)
void | VisitArrayType (const ArrayType *T)
void | VisitVariableArrayType (const VariableArrayType *T)
void | VisitDependentSizedArrayType (const DependentSizedArrayType *T)
void | VisitDependentSizedExtVectorType (const DependentSizedExtVectorType *T)
void | VisitVectorType (const VectorType *T)
void | VisitFunctionType (const FunctionType *T)
void | VisitFunctionProtoType (const FunctionProtoType *T)
void | VisitTypeOfExprType (const TypeOfExprType *T)
void | VisitDecltypeType (const DecltypeType *T)
void | VisitUnaryTransformType (const UnaryTransformType *T)
void | VisitAttributedType (const AttributedType *T)
void | VisitSubstTemplateTypeParmType (const SubstTemplateTypeParmType *T)
void | VisitSubstTemplateTypeParmPackType (const SubstTemplateTypeParmPackType *T)
void | VisitTemplateSpecializationType (const TemplateSpecializationType *T)
void | VisitObjCObjectPointerType (const ObjCObjectPointerType *T)
void | VisitAtomicType (const AtomicType *T)
void | VisitPipeType (const PipeType *T)
void | VisitAdjustedType (const AdjustedType *T)
void | VisitPackExpansionType (const PackExpansionType *T)
void | VisitTypedefDecl (const TypedefDecl *D)
void | VisitEnumConstantDecl (const EnumConstantDecl *D)
void | VisitFunctionDecl (const FunctionDecl *D)
void | VisitFieldDecl (const FieldDecl *D)
void | VisitVarDecl (const VarDecl *D)
void | VisitDecompositionDecl (const DecompositionDecl *D)
void | VisitBindingDecl (const BindingDecl *D)
void | VisitFileScopeAsmDecl (const FileScopeAsmDecl *D)
void | VisitCapturedDecl (const CapturedDecl *D)
void | VisitOMPThreadPrivateDecl (const OMPThreadPrivateDecl *D)
void | VisitOMPDeclareReductionDecl (const OMPDeclareReductionDecl *D)
void | VisitOMPDeclareMapperDecl (const OMPDeclareMapperDecl *D)
void | VisitOMPCapturedExprDecl (const OMPCapturedExprDecl *D)
void | VisitOMPAllocateDecl (const OMPAllocateDecl *D)
void | dumpTemplateDeclSpecialization (const SpecializationDecl *D)
void | dumpTemplateDecl (const TemplateDecl *D)
void | VisitTypeAliasDecl (const TypeAliasDecl *D)
void | VisitTypeAliasTemplateDecl (const TypeAliasTemplateDecl *D)
void | VisitStaticAssertDecl (const StaticAssertDecl *D)
void | VisitFunctionTemplateDecl (const FunctionTemplateDecl *D)
void | VisitClassTemplateDecl (const ClassTemplateDecl *D)
void | VisitClassTemplateSpecializationDecl (const ClassTemplateSpecializationDecl *D)
void | VisitClassTemplatePartialSpecializationDecl (const ClassTemplatePartialSpecializationDecl *D)
void | VisitClassScopeFunctionSpecializationDecl (const ClassScopeFunctionSpecializationDecl *D)
void | VisitVarTemplateDecl (const VarTemplateDecl *D)
void | VisitBuiltinTemplateDecl (const BuiltinTemplateDecl *D)
void | VisitVarTemplateSpecializationDecl (const VarTemplateSpecializationDecl *D)
void | VisitVarTemplatePartialSpecializationDecl (const VarTemplatePartialSpecializationDecl *D)
void | VisitTemplateTypeParmDecl (const TemplateTypeParmDecl *D)
void | VisitNonTypeTemplateParmDecl (const NonTypeTemplateParmDecl *D)
void | VisitTemplateTemplateParmDecl (const TemplateTemplateParmDecl *D)
void | VisitConceptDecl (const ConceptDecl *D)
void | VisitUsingShadowDecl (const UsingShadowDecl *D)
void | VisitFriendDecl (const FriendDecl *D)
void | VisitObjCMethodDecl (const ObjCMethodDecl *D)
void | VisitObjCCategoryDecl (const ObjCCategoryDecl *D)
void | VisitObjCInterfaceDecl (const ObjCInterfaceDecl *D)
void | VisitObjCImplementationDecl (const ObjCImplementationDecl *D)
void | VisitBlockDecl (const BlockDecl *D)
void | VisitDeclStmt (const DeclStmt *Node)
void | VisitAttributedStmt (const AttributedStmt *Node)
void | VisitCXXCatchStmt (const CXXCatchStmt *Node)
void | VisitCapturedStmt (const CapturedStmt *Node)
void | VisitOMPExecutableDirective (const OMPExecutableDirective *Node)
void | VisitInitListExpr (const InitListExpr *ILE)
void | VisitBlockExpr (const BlockExpr *Node)
void | VisitOpaqueValueExpr (const OpaqueValueExpr *Node)
void | VisitGenericSelectionExpr (const GenericSelectionExpr *E)
void | VisitLambdaExpr (const LambdaExpr *Node)
void | VisitSizeOfPackExpr (const SizeOfPackExpr *Node)
void | VisitObjCAtCatchStmt (const ObjCAtCatchStmt *Node)
void | VisitExpressionTemplateArgument (const TemplateArgument &TA)
void | VisitPackTemplateArgument (const TemplateArgument &TA)
Public Member Functions inherited from clang::declvisitor::Base< llvm::make_const_ptr, JSONDumper, void >
void | Visit (PTR(Decl) D)
void | VisitDecl (PTR(Decl) D)
Public Member Functions inherited from clang::StmtVisitorBase< llvm::make_const_ptr, JSONDumper, void, ParamTys... >
void | Visit (PTR(Stmt) S, ParamTys... P)
| BINOP_FALLBACK (PtrMemD) BINOP_FALLBACK(PtrMemI) BINOP_FALLBACK(Mul) BINOP_FALLBACK(Div) BINOP_FALLBACK(Rem) BINOP_FALLBACK(Add) BINOP_FALLBACK(Sub) BINOP_FALLBACK(Shl) BINOP_FALLBACK(LT) BINOP_FALLBACK(GT) BINOP_FALLBACK(LE) BINOP_FALLBACK(GE) BINOP_FALLBACK(EQ) BINOP_FALLBACK(NE) BINOP_FALLBACK(And) BINOP_FALLBACK(Xor) BINOP_FALLBACK(Or) BINOP_FALLBACK(LAnd) BINOP_FALLBACK(LOr) CAO_FALLBACK(MulAssign) CAO_FALLBACK(DivAssign) CAO_FALLBACK(RemAssign) CAO_FALLBACK(AddAssign) CAO_FALLBACK(SubAssign) CAO_FALLBACK(ShlAssign) CAO_FALLBACK(ShrAssign) CAO_FALLBACK(AndAssign) CAO_FALLBACK(OrAssign) UNARYOP_FALLBACK(PostInc) UNARYOP_FALLBACK(PostDec) UNARYOP_FALLBACK(PreInc) UNARYOP_FALLBACK(PreDec) UNARYOP_FALLBACK(AddrOf) UNARYOP_FALLBACK(Deref) UNARYOP_FALLBACK(Plus) UNARYOP_FALLBACK(Minus) UNARYOP_FALLBACK(Not) UNARYOP_FALLBACK(LNot) UNARYOP_FALLBACK(Real) UNARYOP_FALLBACK(Imag) UNARYOP_FALLBACK(Extension) UNARYOP_FALLBACK(Coawait) void VisitStmt(PTR(Stmt) Node
Public Member Functions inherited from clang::comments::CommentVisitorBase< llvm::make_const_ptr, JSONDumper, void, ParamTys... >
void | visit (PTR(Comment) C, ParamTys... P)
void | visitComment (PTR(Comment) C, ParamTys... P)
Public Member Functions inherited from clang::TypeVisitor< JSONDumper >
void | Visit (const Type *T)
| Performs the operation associated with this visitor object. More...
void | VisitType (const Type *)
| Method called if `ImpClass` doesn't provide specific handler for some type class. More...
Public Member Functions inherited from clang::attrvisitor::Base< llvm::make_const_ptr, JSONDumper, void, ParamTys... >
void | Visit (PTR(Attr) A)
void | VisitAttr (PTR(Attr))
Public Member Functions inherited from clang::templateargumentvisitor::Base< llvm::make_const_ref, JSONDumper, void, ParamTys... >
void | Visit (REF(TemplateArgument) TA, ParamTys... P)
| VISIT_METHOD (Null)
| VISIT_METHOD (Type)
| VISIT_METHOD (Declaration)
| VISIT_METHOD (NullPtr)
| VISIT_METHOD (Integral)
| VISIT_METHOD (Template)
| VISIT_METHOD (TemplateExpansion)
| VISIT_METHOD (Expression)
| VISIT_METHOD (Pack)
void | VisitTemplateArgument (REF(TemplateArgument), ParamTys...)

## Additional Inherited Members
Public Attributes inherited from clang::StmtVisitorBase< llvm::make_const_ptr, JSONDumper, void, ParamTys... >
ParamTys | P

## Detailed Description

Definition at line 346 of file JSONNodeDumper.h.

## Constructor & Destructor Documentation

## ◆ JSONDumper()

clang::JSONDumper::JSONDumper | ( | raw_ostream & | OS,
|  | const SourceManager & | SrcMgr,
|  | ASTContext & | Ctx,
|  | const PrintingPolicy & | PrintPolicy,
|  | const comments::CommandTraits * | Traits
| ) |  |
| inline

Definition at line 410 of file JSONNodeDumper.h.

## Member Function Documentation

## ◆ doGetNodeDelegate()

JSONNodeDumper& clang::JSONDumper::doGetNodeDelegate | ( |  | ) |
| inline

Definition at line 415 of file JSONNodeDumper.h.

## ◆ VisitClassTemplateDecl()

void clang::JSONDumper::VisitClassTemplateDecl | ( | const ClassTemplateDecl * | CTD | ) |
| inline

Definition at line 420 of file JSONNodeDumper.h.

## ◆ VisitFunctionTemplateDecl()

void clang::JSONDumper::VisitFunctionTemplateDecl | ( | const FunctionTemplateDecl * | FTD | ) |
| inline

Definition at line 417 of file JSONNodeDumper.h.

## ◆ VisitVarTemplateDecl()

void clang::JSONDumper::VisitVarTemplateDecl | ( | const VarTemplateDecl * | VTD | ) |
| inline

Definition at line 423 of file JSONNodeDumper.h.

The documentation for this class was generated from the following file:

- include/clang/AST/JSONNodeDumper.h